;- TOP

; Komment   : OPC Test 
; Version   : v2.2
; Erstellt  : 15.05.2009
; Gendert  : 
; Author    : Michael Kastner (mk-soft)

; Compiler  : Unicode

; *********************************************************************************************************

IncludeFile "PBOPC.pbi"
IncludeFile "PBOPC_Help.pbi"
IncludeFile "VariantHelper_Include.pb"

; *********************************************************************************************************

#OPC_QUALITY_BAD = $00
#OPC_QUALITY_UNCERTAIN = $40
#OPC_QUALITY_GOOD = $C0
#OPC_QUALITY_CONFIG_ERROR = $04
#OPC_QUALITY_NOT_CONNECTED = $08
#OPC_QUALITY_DEVICE_FAILURE = $0c
#OPC_QUALITY_SENSOR_FAILURE = $10
#OPC_QUALITY_LAST_KNOWN = $14
#OPC_QUALITY_COMM_FAILURE = $18
#OPC_QUALITY_OUT_OF_SERVICE = $1C
#OPC_QUALITY_LAST_USABLE = $44
#OPC_QUALITY_SENSOR_CAL = $50
#OPC_QUALITY_EGU_EXCEEDED = $54
#OPC_QUALITY_SUB_NORMAL = $58
#OPC_QUALITY_LOCAL_OVERRIDE = $D8

; *********************************************************************************************************

Procedure test()
; OPC Server verbinden
  Debug "OPC Server verbinden"
  *Server = OpcConnect("INAT TCPIPH1 OPC Server", "")
  Debug GetErrorString(*Server, OpcGetLastError())
  If *Server = 0
    ProcedureReturn 0
  EndIf
  Debug "Fertig."
  ; Gruppe anlegen
  Debug "Gruppe anlegen"
  *Group = OpcAddGroup(*Server, "Test")
  Debug GetErrorString(*Server, OpcGetLastError())
  If *Group = 0
    ProcedureReturn 0
  EndIf
  ; Items anlegen
  Debug "Items anlegen"
  Dim *items(4)
  *items(0) = OpcAddItem(*Group, "", "Labor.mw4")
  *items(1) = OpcAddItem(*Group, "", "Labor.db100.byte0,500")
  *items(2) = OpcAddItem(*Group, "", "Labor.db101.int0,500")
  *items(3) = OpcAddItem(*Group, "", "Labor.db102,real0,500")
  Debug "Fertig."
  
  ; wait for plc
  Debug "PLC Verbinung pfen"
  value1.l
  quality.l
  Repeat
    r1 = OpcReadWord(*items(0), @value1, @quality)
    If r1
      Debug GetErrorString(*Server, r1)
      OpcRelease(*server)
      End
    EndIf
    If quality = #OPC_QUALITY_GOOD
      Break
    Else
      count + 1
      If count > 10
        OpcRelease(*Server)
        Debug "PLC Offline"
        End
      EndIf
    EndIf
    Delay(100)
  ForEver
  Debug "Fertig."
  
  Debug "Alle Items lesen"
  Dim Result.variant(4)
  Dim Quality.l(4)
  Dim Errors.l(4)
  
  r1 = OpcReadItems(4 ,*items(), result(), quality(), Errors())
  If r1
    Debug GetErrorString(*Server, r1)
  EndIf
  For i = 0 To 3
    Debug "Value: " + VT_STR(result(i)) + " Quality: " + GetQualityText(quality(i))
  Next
  
  Debug "SafeArray fllen"
  *psa2.safearray = saCreateSafeArray(#VT_I2, 0, 500)
  For i = saLBound(*psa2) To saUBound(*psa2)
    sa_word(*psa2, i) = i
  Next
  
  *psa3.safearray = saCreateSafeArray(#VT_R4, 0, 500)
  For i = saLBound(*psa3) To saUBound(*psa3)
    sa_float(*psa3, i) = 0.5 + i
  Next
  
  Debug "SafeArray schreiben"
  Dim values.variant(4)
  V_ARRAY_WORD(values(2)) = *psa2
  V_ARRAY_FLOAT(values(3)) = *psa3
  r1 = OpcWriteItems(3, @*items(1), @values(1), @Errors(1))
  If r1
    Debug GetErrorString(*Server, r1)
  EndIf
  For i = 1 To 3
    Debug "Result " + Str(i) + ": " + GetErrorString(*Server, Errors(i))
  Next
  
  Debug "Fertig"    
  
  
  ; Server beenden - Intern werden automatisch die Gruppen gelscht (OpcRemoveGroup(...))
  Debug "Beenden Server"
  hResult = OpcRelease(*Server)
  Debug "Fertig"
  
EndProcedure

test()

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 82
; FirstLine = 61
; Folding = -
; EnableUnicode