;- TOP

; Komment   : OPC Test 
; Version   : v2.2
; Erstellt  : 15.05.2009
; Gendert  : 
; Author    : Michael Kastner (mk-soft)

; Compiler  : Unicode

; *********************************************************************************************************

;IncludeFile "OPCFunctionsV22.pb"
IncludeFile "PBOPC.pbi"
IncludeFile "PBOPC_Help.pbi"
IncludeFile "VariantHelper_Include.pb"

; *********************************************************************************************************

#OPC_QUALITY_BAD = $00
#OPC_QUALITY_UNCERTAIN = $40
#OPC_QUALITY_GOOD = $C0
#OPC_QUALITY_CONFIG_ERROR = $04
#OPC_QUALITY_NOT_CONNECTED = $08
#OPC_QUALITY_DEVICE_FAILURE = $0c
#OPC_QUALITY_SENSOR_FAILURE = $10
#OPC_QUALITY_LAST_KNOWN = $14
#OPC_QUALITY_COMM_FAILURE = $18
#OPC_QUALITY_OUT_OF_SERVICE = $1C
#OPC_QUALITY_LAST_USABLE = $44
#OPC_QUALITY_SENSOR_CAL = $50
#OPC_QUALITY_EGU_EXCEEDED = $54
#OPC_QUALITY_SUB_NORMAL = $58
#OPC_QUALITY_LOCAL_OVERRIDE = $D8

; *********************************************************************************************************

Procedure test()
; OPC Server verbinden
  Debug "OPC Server verbinden"
  *Server = OpcConnect("INAT TCPIPH1 OPC Server", "")
  Debug GetErrorString(*Server, OpcGetLastError())
  If *Server = 0
    ProcedureReturn 0
  EndIf
  Debug "Fertig."
  ; Gruppe anlegen
  Debug "Gruppe anlegen"
  *Group = OpcAddGroup(*Server, "Test")
  Debug GetErrorString(*Server, OpcGetLastError())
  If *Group = 0
    ProcedureReturn 0
  EndIf
  ; Items anlegen
  Debug "Items anlegen"
  Dim *items(5)
  prefix.s = "Labor."
  *items(0) = OpcAddItem(*Group, "", prefix + "mb4")
  *items(1) = OpcAddItem(*Group, "", prefix + "db10,dw0dt") ; PLC DateTime
  *items(2) = OpcAddItem(*Group, "", prefix + "db10,dw8dt")
  *items(3) = OpcAddItem(*Group, "", prefix + "db10,dw16dt")
  *items(4) = OpcAddItem(*Group, "", prefix + "db10,dw24dt")
  Debug "Fertig."
  
  ; wait for plc
  Debug "PLC Verbindung pfen"
  value1.l
  quality.l
  Repeat
    r1 = OpcReadWord(*items(0), @value1, @quality)
    If r1
      Debug GetErrorString(*Server, r1)
      OpcRelease(*server)
      End
    EndIf
    If quality = #OPC_QUALITY_GOOD
      Break
    Else
      count + 1
      If count > 10
        OpcRelease(*Server)
        Debug "PLC Offline"
        End
      EndIf
    EndIf
    Delay(100)
  ForEver
  Debug "Fertig."
  
  Debug "Alle Items lesen"
  Dim Result.variant(4)
  Dim Quality.l(4)
  Dim Errors.l(4)
  
  r1 = OpcReadItems(5 ,*items(), result(), quality(), Errors())
  If r1
    Debug GetErrorString(*Server, r1)
  EndIf
  For i = 0 To 4
    Debug "Value: " + VT_STR(result(i)) + " Quality: " + GetQualityText(quality(i))
  Next
  
  Debug "Item 2 schreiben (Variant)"
  r1 = OpcWriteVariant(*items(2), @result(1))
  If r1
    Debug GetErrorString(*Server, r1)
  EndIf
  For i = 0 To 3
    Debug "Result " + Str(i) + ": " + GetErrorString(*Server, Errors(i))
  Next

  Debug "Item 3 schreiben (Items)"
  r1 = OpcWriteItems(1, @*items(3), @result(2), @Errors(3))
  If r1
    Debug GetErrorString(*Server, r1)
  EndIf
  
  datum.variant\vt = #VT_DATE
  datum\dblVal = T_DATE(Date())
  datum2.d = T_DATE(Date())
  Debug "Item 4 schreiben (PC Zeit)"
  r1 = OpcWriteItems(1, @*items(4), datum, @Errors(4)) ; Inat OPC DateTime adjustment
  ;r1 = OpcWriteVariant(*items(4), datum) : Errors(4) = r1 ; failt because Inat DateTime is VT_BSTR
  ;r1 = OpcWriteDate(*items(4), datum2) : Errors(4) = r1 ; Inat OPC DateTime adjustment
  If r1
    Debug GetErrorString(*Server, r1)
  EndIf
  
  For i = 0 To 4
    Debug "Result " + Str(i) + ": " + GetErrorString(*Server, Errors(i))
  Next
  
  Debug "Fertig"    
  
  ; Server beenden - Intern werden automatisch die Gruppen gelscht (OpcRemoveGroup(...))
  Debug "Beenden Server"
  hResult = OpcRelease(*Server)
  Debug "Fertig"
  
EndProcedure

test()

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 85
; FirstLine = 61
; Folding = -
; EnableUnicode