
Public Class Form1

    Private Test2Stop As Boolean

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()

    End Sub

    Private Sub Test1ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Test1ToolStripMenuItem.Click

        Dim server As Int32
        Dim group As Int32
        Dim result As Int32
        Dim info As String

        Dim items(10) As Int32
        Dim prefix As String
        Dim count
        Dim quality As Int32
        Dim bVal As Byte
        Dim bstrVal, buffer As String

        ' Opc Serververbindung starten
        fct.WriteLog("OPC Verbindung starten...")
        server = PB.OpcConnect("INAT TCPIPH1 OPC Server", "")
        If server = 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
            Exit Sub
        Else
            fct.WriteLog("Ok. ServerID=" & server)
        End If

        ' Gruppe anlegen
        fct.WriteLog("Gruppe anlegen...")
        group = PB.OpcAddGroup(server, "Test")
        If group = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        Else
            fct.WriteLog("Ok. GroupID=" & group)
        End If

        ' Items anlegen
        fct.WriteLog("Items anlegen...")
        prefix = "labor."
        items(0) = PB.OpcAddItem(group, "", prefix & "mb4")
        If items(0) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        Else
            fct.WriteLog("Ok. ItemID(0)=" & items(0))
        End If
        ' Warten auf PLC"
        fct.WriteLog("Warten auf PLC...")
        count = 0
        quality = 0
        My.Application.DoEvents()
        Do
            fct.WriteLog("Lese Item...")
            result = PB.OpcReadByte(items(0), bVal, quality)
            If result <> 0 Then
                info = PB.OpcGetErrorString(server, result)
                fct.WriteLog(info)
                GoTo ende
            End If
            If quality = &HC0 Then
                Exit Do
            Else
                count = count + 1
                If count > 10 Then
                    fct.WriteLog("PLC Offline")
                    GoTo ende
                End If
            End If
            My.Application.DoEvents()

        Loop
        fct.WriteLog("PLC Online: Value=" & bVal & " - Quality= " & PB.OpcGetQualityText(quality))

        ' Items lesen
        buffer = Space(100) ' ??? String buffer so mglich
        result = PB.OpcReadString(items(0), buffer, 100, quality)
        If result < 0 Then
            info = PB.OpcGetErrorString(server, result)
            fct.WriteLog(info)
        Else
            bstrVal = Strings.Left(buffer, InStr(buffer, Chr(0)) - 1)
            fct.WriteLog("Value=" & bstrVal & " - Quality= " & PB.OpcGetQualityText(quality))
        End If

ende:
        ' Opc Gruppe entfernen
        fct.WriteLog("OPC Gruppe trennen")
        result = PB.OpcRemoveGroup(group)
        If result < 0 Then
            info = PB.OpcGetErrorString(server, result)
            fct.WriteLog(info)
        Else
            fct.WriteLog("Ok. Result=" & result)
        End If
        ' Opc Serververbindung beenden
        fct.WriteLog("OPC Verbindung trennen")
        result = PB.OpcRelease(server)
        If result < 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
        Else
            fct.WriteLog("Ok. Result=" & result)
        End If
    End Sub


    Private Sub Test2StopToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Test2StopToolStripMenuItem.Click
        Test2Stop = True
    End Sub

    Private Sub Test2StartToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Test2StartToolStripMenuItem.Click

        Dim server As Int32
        Dim shutdown As Int32
        Dim group As Int32
        Dim result As Int32
        Dim info As String

        Dim items(10) As Int32
        Dim prefix As String
        Dim count
        Dim quality As Int32
        Dim bVal As Byte

        Test2Stop = False
        ' Opc Serververbindung starten
        fct.WriteLog("OPC Verbindung starten...")
        server = PB.OpcConnect("INAT TCPIPH1 OPC Server", "")
        If server = 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
            Exit Sub
        Else
            fct.WriteLog("Ok. ServerID=" & server)
        End If
        ' Opc Init Shutdown
        fct.WriteLog("OPC Init Shutdown...")
        shutdown = PB.OpcInitShutdown(server)
        If shutdown = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        Else
            fct.WriteLog("Ok.")
        End If

        ' Opc Set Callback
        fct.WriteLog("OPC Set Callback...")
        result = PB.OpcSetShutdownCallBack(shutdown, AddressOf fct.MyCallback)
        fct.WriteLog("Ok.  OldCallback=" & result)


        ' Gruppe anlegen
        fct.WriteLog("Gruppe anlegen...")
        group = PB.OpcAddGroup(server, "Test")
        If group = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        Else
            fct.WriteLog("Ok. GroupID=" & group)
        End If

        ' Items anlegen
        fct.WriteLog("Items anlegen...")
        prefix = "labor."
        items(0) = PB.OpcAddItem(group, "", prefix & "mb4")
        If items(0) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        Else
            fct.WriteLog("Ok. ItemID(0)=" & items(0))
        End If
        ' Warten auf PLC"
        fct.WriteLog("Warten auf PLC...")
        count = 0
        quality = 0
        My.Application.DoEvents()
        fct.IsShutdown = False
        Do
            fct.WriteLog("Lese Item...")
            result = PB.OpcReadByte(items(0), bVal, quality)
            If result <> 0 Then
                info = PB.OpcGetErrorString(server, result)
                fct.WriteLog(info)
                GoTo ende
            End If
            If quality = &HC0 Then
                Exit Do
            Else
                count = count + 1
                If count > 10 Then
                    fct.WriteLog("PLC Offline")
                    GoTo ende
                End If
            End If
            My.Application.DoEvents()

        Loop
        fct.WriteLog("PLC Online: Value=" & bVal & " - Quality= " & PB.OpcGetQualityText(quality))

        While fct.IsShutdown = False And Test2Stop = False

            ' Items lesen
            result = PB.OpcReadByte(items(0), bVal, quality)
            If result < 0 Then
                info = PB.OpcGetErrorString(server, result)
                fct.WriteLog(info)
            Else
                fct.WriteLog("Value=" & bVal & " - Quality= " & PB.OpcGetQualityText(quality))
            End If
            My.Application.DoEvents()

        End While

ende:
        ' Opc Gruppe entfernen
        fct.WriteLog("OPC Gruppe trennen")
        result = PB.OpcRemoveGroup(group)
        If result < 0 Then
            info = PB.OpcGetErrorString(server, result)
            fct.WriteLog(info)
        Else
            fct.WriteLog("Ok. Result=" & result)
        End If

        ' Opc Shutdown beenden
        fct.WriteLog("OPC Shutdown trennen")
        result = PB.OpcReleaseShutdown(shutdown)
        If result < 0 Then
            info = PB.OpcGetErrorString(server, result)
            fct.WriteLog(info)
        Else
            fct.WriteLog("Ok. Result=" & result)
        End If
        ' Opc Serververbindung beenden
        fct.WriteLog("OPC Verbindung trennen")
        result = PB.OpcRelease(server)
        If result < 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
        Else
            fct.WriteLog("Ok. Result=" & result)
        End If

        fct.WriteLog("Ende.")

    End Sub



    Private Sub Test3ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Test3ToolStripMenuItem.Click

        Dim server As Int32
        Dim group As Int32
        Dim result As Int32
        Dim info As String

        Dim prefix As String
        Dim count
        Dim quality As Int32
        Dim bVal As Byte
        Dim item As Int32


        Dim items(10) As Int32
        Dim values(10) As Object
        Dim qualitys(10) As Int32
        Dim errors(10) As Int32

        ' Opc Serververbindung starten
        fct.WriteLog("OPC Verbindung starten...")
        server = PB.OpcConnect("INAT TCPIPH1 OPC Server", "")
        If server = 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
            Exit Sub
        Else
            fct.WriteLog("Ok.")
        End If

        ' Gruppe anlegen
        fct.WriteLog("Gruppe anlegen...")
        group = PB.OpcAddGroup(server, "Test")
        If group = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        Else
            fct.WriteLog("Ok." & group)
        End If

        ' Items anlegen
        fct.WriteLog("Items anlegen...")
        prefix = "labor."
        item = PB.OpcAddItem(group, "", prefix & "mb4")
        If item = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If

        items(0) = PB.OpcAddItem(group, "", prefix & "mw160")
        If items(0) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(1) = PB.OpcAddItem(group, "", prefix & "mdint162")
        If items(1) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(2) = PB.OpcAddItem(group, "", prefix & "mreal166")
        If items(2) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(3) = PB.OpcAddItem(group, "", prefix & "mstring170.20")
        If items(3) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(4) = PB.OpcAddItem(group, "", prefix & "mw190dt")
        If items(4) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        fct.WriteLog("Ok.")
        ' Warten auf PLC"
        fct.WriteLog("Warten auf PLC...")
        count = 0
        quality = 0
        My.Application.DoEvents()
        Do
            fct.WriteLog("Lese Item...")
            result = PB.OpcReadByte(item, bVal, quality)
            If result <> 0 Then
                info = PB.OpcGetErrorString(server, result)
                fct.WriteLog(info)
                GoTo ende
            End If
            If quality = &HC0 Then
                Exit Do
            Else
                count = count + 1
                If count > 10 Then
                    fct.WriteLog("PLC Offline")
                    GoTo ende
                End If
            End If
            My.Application.DoEvents()

        Loop
        fct.WriteLog("PLC Online: Value=" & bVal & " - Quality= " & PB.OpcGetQualityText(quality))
        ' Items lesen

        'result = PB.OpcReadVariant(items(1), value, quality)
        result = PB.OpcReadItemArray(5, items, values, qualitys, errors)
        If result < 0 Then
            info = PB.OpcGetErrorString(server, result)
            fct.WriteLog(info)
        Else
            For count = 0 To 4
                fct.WriteLog("Value=" & values(count) & " - Quality= " & PB.OpcGetQualityText(qualitys(count)))
            Next
        End If


        ' Opc Serververbindung beenden
ende:   fct.WriteLog("OPC Verbindung trennen")
        result = PB.OpcRelease(server)
        If result < 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
        Else
            fct.WriteLog("Ok. Result=" & result)
        End If

    End Sub

    Private Sub Test4ObjectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Test4ObjectToolStripMenuItem.Click

        Dim server As Int32
        Dim group As Int32
        Dim result As Int32
        Dim info As String

        Dim prefix As String
        Dim count
        Dim quality As Int32
        Dim bVal As Byte
        Dim item As Int32


        Dim items(10) As Int32
        Dim values(10) As Object
        Dim qualitys(10) As Int32
        Dim errors(10) As Int32

        ' Opc Serververbindung starten
        fct.WriteLog("OPC Verbindung starten...")
        server = PB.OpcConnect("INAT TCPIPH1 OPC Server", "")
        If server = 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
            Exit Sub
        Else
            fct.WriteLog("Ok.")
        End If

        ' Gruppe anlegen
        fct.WriteLog("Gruppe anlegen...")
        group = PB.OpcAddGroup(server, "Test")
        If group = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        Else
            fct.WriteLog("Ok." & group)
        End If

        ' Items anlegen
        fct.WriteLog("Items anlegen...")
        prefix = "labor."
        item = PB.OpcAddItem(group, "", prefix & "mb4")
        If item = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If

        items(0) = PB.OpcAddItem(group, "", prefix & "mw160")
        If items(0) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(1) = PB.OpcAddItem(group, "", prefix & "mdint162")
        If items(1) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(2) = PB.OpcAddItem(group, "", prefix & "mreal166")
        If items(2) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(3) = PB.OpcAddItem(group, "", prefix & "mstring170.20")
        If items(3) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        items(4) = PB.OpcAddItem(group, "", prefix & "mw190dt")
        If items(4) = 0 Then
            info = PB.OpcGetErrorString(server, PB.OpcGetLastError())
            fct.WriteLog(info)
            GoTo ende
        End If
        fct.WriteLog("Ok.")
        ' Warten auf PLC"
        fct.WriteLog("Warten auf PLC...")
        count = 0
        quality = 0
        My.Application.DoEvents()
        Do
            fct.WriteLog("Lese Item...")
            result = PB.OpcReadByte(item, bVal, quality)
            If result <> 0 Then
                info = PB.OpcGetErrorString(server, result)
                fct.WriteLog(info)
                GoTo ende
            End If
            If quality = &HC0 Then
                Exit Do
            Else
                count = count + 1
                If count > 10 Then
                    fct.WriteLog("PLC Offline")
                    GoTo ende
                End If
            End If
            My.Application.DoEvents()

        Loop
        fct.WriteLog("PLC Online: Value=" & bVal & " - Quality= " & PB.OpcGetQualityText(quality))
        ' Items lesen

        values(0) = 100
        values(1) = 200
        values(2) = "20,99"
        values(3) = "Hallo Welt"
        values(4) = Now

        result = PB.OpcWriteItemArray(5, items, values, errors)
        If result < 0 Then
            info = PB.OpcGetErrorString(server, result)
            fct.WriteLog(info)
        Else
            For count = 0 To 4
                fct.WriteLog("Value(" & count & ") = " & values(count) & " - ErrorsResult = " & PB.OpcGetErrorString(server, errors(count)))
            Next
        End If


        ' Opc Serververbindung beenden - OpcRelease ruft intern OpcRemoceGroup auf
ende:   fct.WriteLog("OPC Verbindung trennen")
        result = PB.OpcRelease(server)
        If result < 0 Then
            info = PB.OpcGetErrorString(0, PB.OpcGetLastError())
            fct.WriteLog(info)
        Else
            fct.WriteLog("Ok. Result=" & result)
        End If


    End Sub
End Class
